/*
 * Verilog Behavioral Simulator version 1.0.0
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Special Contributions:
 *
 * The authors of this software would like to thank the University of 
 * Hawaii, College of Engineering for the use of their computer 
 * facilities in the course of the development of this software.  Special 
 * thanks to Dr. Alex Quilici, who is the advisor for this project, and Dr. 
 * Michael Smith, who taught us how to use Verilog.  We would also like
 * to thank the College of Engineering for the knowledge we have gained
 * through their engineering curriculum.
 *
 * Authors:
 *	Lay Hoon Tho
 *		8, Jalan Setia 6 Chamek,
 *		Kluang, 86000 Johore,
 *		Malaysia
 *
 *	Jimen Ching
 *		2108 Citron St. Apt. #2
 *		Honolulu, HI 96826
 *		USA
 *		(jching@aloha.com)
 */
module main;
	reg bit;
	reg [3:0] bitvector;

	initial
		begin
		bit = 1;
		bitvector = 22;
		$write("%d: %d(1) %d(22\%4) (ok)\n", $time, bit, bitvector);
		#10 bit = 1'b0;
		#10 bitvector = 4'd13;
		$write("%d: %d(0) (ok) %d(13)\n", $time, bit, bitvector);
		#100 bit = 1'b1;
		$write("%d: (ok) %d(1) %d(13)\n", $time, bit, bitvector);
		#5000 bitvector = 4'd6;
		$write("(ok) %d: %d(1) %d(6)\n", $time, bit, bitvector);
		$finish;
		#10 bit = 1;
		$write("%d %d %d (We don't get here).\n",
			$time, bit, bitvector);
		end
endmodule
