/*
 * Verilog Behavioral Simulator version 1.0.0
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Special Contributions:
 *
 * The authors of this software would like to thank the University of 
 * Hawaii, College of Engineering for the use of their computer 
 * facilities in the course of the development of this software.  Special 
 * thanks to Dr. Alex Quilici, who is the advisor for this project, and Dr. 
 * Michael Smith, who taught us how to use Verilog.  We would also like
 * to thank the College of Engineering for the knowledge we have gained
 * through their engineering curriculum.
 *
 * Authors:
 *	Lay Hoon Tho
 *		8, Jalan Setia 6 Chamek,
 *		Kluang, 86000 Johore,
 *		Malaysia
 *
 *	Jimen Ching
 *		2108 Citron St. Apt. #2
 *		Honolulu, HI 96826
 *		USA
 *		(jching@aloha.com)
 */
/* Testing 'if' statement. */
module main;
	reg [0:3] a,b,c;

	initial
		begin
		a = 0;  /* initialize variables */
		b = 5;
		c = 10;
		$write("time %d: %d %d %d (0 5 10)\n",$time,a,b,c);
		if (a != b) 
			begin
			#1 c = ~c + 2 + 1; 	/* c = 8 */
			$write("time %d: %d %d %d (time 1: 0 5 8)\n",
				$time,a,b,c);
			#2 b = ~b;		/* b = 10 */
			$write("time %d: %d %d %d (time 3: 0 10 8)\n",
				$time,a,b,c);
			#3 a = 1;
			$write("time %d: %d %d %d (time 6: 1 10 8)\n",
				$time,a,b,c);
			end
		#1 $write("time %d: %d %d %d (time 7: 1 10 8)\n",
			$time,a,b,c);
		#2 if (~b)
			begin
			a = ~b;
			c = 3;
			$write("time %d: %d %d %d (time 9: 5 10 3)\n",
				$time,a,b,c);
			end
		$write("time %d: %d %d %d (time 9: 5 10 3)\n",
			$time,a,b,c);
		if (!a)
			$write("Went through a false test.\n");
		$write("time %d: %d %d %d (time 9: 5 10 3)\n",
			$time,a,b,c);
		$finish;
		end

endmodule
