/*
 * Verilog Behavioral Simulator version 1.0.0
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Special Contributions:
 *
 * The authors of this software would like to thank the University of 
 * Hawaii, College of Engineering for the use of their computer 
 * facilities in the course of the development of this software.  Special 
 * thanks to Dr. Alex Quilici, who is the advisor for this project, and Dr. 
 * Michael Smith, who taught us how to use Verilog.  We would also like
 * to thank the College of Engineering for the knowledge we have gained
 * through their engineering curriculum.
 *
 * Authors:
 *	Lay Hoon Tho
 *		8, Jalan Setia 6 Chamek,
 *		Kluang, 86000 Johore,
 *		Malaysia
 *
 *	Jimen Ching
 *		2108 Citron St. Apt. #2
 *		Honolulu, HI 96826
 *		USA
 *		(jching@aloha.com)
 */
/* File:  oror.v, test || comparison. */
module main;
	reg [0:8] a,b,c;

	initial
		begin
		a = 0;
		b = 0;
		c = 1;
		#1 if (a == b && c == 1)
			begin
			a = 2;
			b = a;
			c = b;
		 	a = 9;	/* a=9, b=2, c=2 */
			end
		$write("%d: %d %d %d\n",$time,a,b,c);
		#1 if (a != b || b == c)
			begin
			c = 3;	/* a=9, b=2, c=3 */
			end
		#1 $write("0: 0 0 1\n");
		$write("1: 9 2 2\n");
		$write("2: 9 2 3\n");
		#1 $finish;
		end

	always @(a or b or c)		
		$write("monitor %d: %d %d %d\n",$time,a,b,c);

endmodule
