/*
 * Verilog Behavioral Simulator version 1.0.0
 * Copyright (C) 1995 Lay Hoon Tho, Jimen Ching
 *
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * Special Contributions:
 *
 * The authors of this software would like to thank the University of 
 * Hawaii, College of Engineering for the use of their computer 
 * facilities in the course of the development of this software.  Special 
 * thanks to Dr. Alex Quilici, who is the advisor for this project, and Dr. 
 * Michael Smith, who taught us how to use Verilog.  We would also like
 * to thank the College of Engineering for the knowledge we have gained
 * through their engineering curriculum.
 *
 * Authors:
 *	Lay Hoon Tho
 *		8, Jalan Setia 6 Chamek,
 *		Kluang, 86000 Johore,
 *		Malaysia
 *
 *	Jimen Ching
 *		2108 Citron St. Apt. #2
 *		Honolulu, HI 96826
 *		USA
 *		(jching@aloha.com)
 */
/* Test range selection of registers. */
module main;
	reg [0:7] a;
	reg [0:7] b;
	reg [7:0] c;
	reg [7:0] d;

	initial
		begin
		a = 0;
		b = 0;
		c = 0;
		d = 0;
		a[3:4] = 8'b00000010;
		b[3:4] = 8'b00000001;
		c[4:3] = 8'b00000001;
		d[4:3] = 8'b00000010;
		$write("a=%b(000 10 000) b=%b(000 01 000)\n",a,b);
		$write("c=%b(000 01 000) d=%b(000 10 000)\n",c,d);
		d[6:2] = b[1:3] + c[6:2];
		$write("d=%b (000 01 000)\n",d);
		d[6:6] = 1;
		$write("d=%b (010 01 000)\n",d);
		d[1:1] = d[3:3];
		$write("d=%b (010 01 010)\n",d);
		end

endmodule
